﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Xml.Serialization;

namespace CsSoundStudy
{
  class MainProgram
  {
    [STAThread]
    static void Main(string[] args)
    {
      XmlSerializer xmlout = new XmlSerializer(typeof(WaveFile));
      Stream writer = new FileStream("..//..//фрагмент15000smpl.xml", FileMode.Create);
      string temp;
      string strFileName = "..//..//фрагмент15000smpl.wav";
      WaveFileReader reader;
      try
      {
        reader = new WaveFileReader(strFileName);
      }
      catch (FileNotFoundException e)
      {
        Console.WriteLine("Файл WAV не найден");
        Console.ReadKey();
        return;
      }
      WaveFile contents = new WaveFile();
      contents.maindata = reader.ReadMainFileHeader();
      contents.maindata.FileName = strFileName;
      while (reader.GetPosition() < (long)contents.maindata.dwFileLength)
      {
        temp = reader.GetChunkName();
        if (temp == "fmt ")
        {
          contents.format = reader.ReadFormatHeader();
          if (reader.GetPosition() + contents.format.dwChunkSize == contents.maindata.dwFileLength)
            break;
        }
        else if (temp == "fact")
        {
          contents.fact = reader.ReadFactHeader();
          if (reader.GetPosition() + contents.fact.dwChunkSize == contents.maindata.dwFileLength)
            break;
        }
        else if (temp == "data")
        {
          contents.data = reader.ReadDataHeader();
          if (reader.GetPosition() + contents.data.dwChunkSize == contents.maindata.dwFileLength)
            break;
        }
        else
        {	
          reader.AdvanceToNext();
        }
      }
      Console.WriteLine("Длина файла (байт): {0}", contents.maindata.dwFileLength);
      Console.WriteLine("Количество каналов: {0}", contents.format.wChannels);
      Console.WriteLine("Число битов на отчет: {0}", contents.format.dwBitsPerSample);
      //Console.WriteLine("Число отчетов аудио в файле: {0}", contents.data.dwNumSamples);
      //Console.WriteLine("Позиция чанка данных в файле: {0}", contents.data.lFilePosition.ToString());
      xmlout.Serialize(writer, contents);
      reader.Dispose();
      Console.ReadKey();
      return;
    }
  }

  public class WaveFile
  {
    public riffChunk maindata;
    public fmtChunk format;
    public factChunk fact;
    public dataChunk data;
  }
}
